diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index b3675369c..4d678cdf0 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -12,7 +12,6 @@ import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
-import net.minecraft.core.world.particle.ParticleEmitterRange;
 import net.minecraft.core.world.pos.ChunkSectionTilePos;
 import net.minecraft.core.world.pos.ChunkPos;
 import net.minecraft.core.world.pos.ChunkPosc;
@@ -68,6 +67,7 @@ public class Chunk {
     public int averageBlockHeight;
     public boolean isTerrainPopulated = false;
     public boolean isModified = false;
+    public boolean sentToClients = false;
     public boolean neverSave;
     public boolean hasEntities = false;
     public long lastSaveTime = 0L;
@@ -684,42 +684,6 @@ public class Chunk {
         for (ChunkSection section : this.sections) {
             section.onLoad(this.world);
         }
-
-        if (!this.world.isClientSide) {
-            this.registerParticleEmittersFromLoadedBlocks();
-        }
-    }
-
-    /**
-     * Registers particle emitter blocks in this chunk on the server.
-     */
-    private void registerParticleEmittersFromLoadedBlocks() {
-        final ChunkSectionTilePos sectionTile = new ChunkSectionTilePos();
-        for (final ChunkSection section : this.sections) {
-            if (section.blocks == null) {
-                continue;
-            }
-            final int baseY = section.yPosition * ChunkSection.SECTION_SIZE_Y;
-            for (sectionTile.y = 0; sectionTile.y < ChunkSection.SECTION_SIZE_Y; sectionTile.y++) {
-                for (sectionTile.z = 0; sectionTile.z < CHUNK_SIZE_Z; sectionTile.z++) {
-                    for (sectionTile.x = 0; sectionTile.x < CHUNK_SIZE_X; sectionTile.x++) {
-                        final int id = section.getBlockId(sectionTile);
-                        if (id == 0) {
-                            continue;
-                        }
-                        final Block<?> block = Blocks.getBlock(id);
-                        final ParticleEmitterRange range = block.getLogic().getParticleEmitterRange();
-                        if (range == null) {
-                            continue;
-                        }
-                        final int wx = this.pos.x * CHUNK_SIZE_X + sectionTile.x;
-                        final int wy = baseY + sectionTile.y;
-                        final int wz = this.pos.z * CHUNK_SIZE_Z + sectionTile.z;
-                        this.world.particleEmitters.add(new TilePos(wx, wy, wz), range);
-                    }
-                }
-            }
-        }
     }
 
     public void onUnload() {
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/PositionSelectors.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/PositionSelectors.java
index 59064ac5a..2f87042a9 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/PositionSelectors.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/PositionSelectors.java
@@ -8,6 +8,8 @@ import org.jetbrains.annotations.NotNull;
 import java.util.Random;
 
 public class PositionSelectors {
+    private static final int DECORATION_OFFSET = 8;
+
     public static class HeightRangeUniform implements PositionSelector {
 
         private final int range;
@@ -19,59 +21,59 @@ public class PositionSelectors {
         @Override
         public TilePos getValue(@NotNull World world, @NotNull Chunk chunk, @NotNull Random random, int minY, int maxY, int rangeY) {
 
-            int x = (chunk.pos.x() * 16) + random.nextInt(16);
-            int z = (chunk.pos.z() * 16) + random.nextInt(16);
+            int x = (chunk.pos.x() * 16) + random.nextInt(16) + DECORATION_OFFSET;
+            int z = (chunk.pos.z() * 16) + random.nextInt(16) + DECORATION_OFFSET;
             int y = minY + random.nextInt(rangeY / range);
             return new TilePos(x, y, z);
         }
     }
 
     public static PositionSelector MinY = (world, chunk, random, minY, maxY, rangeY) -> {
-        int x = (chunk.pos.x() * 16) + random.nextInt(16);
-        int z = (chunk.pos.z() * 16) + random.nextInt(16);
+        int x = (chunk.pos.x() * 16) + random.nextInt(16) + DECORATION_OFFSET;
+        int z = (chunk.pos.z() * 16) + random.nextInt(16) + DECORATION_OFFSET;
 
         return new TilePos(x, minY, z);
     };
 
 
     public static PositionSelector MaxY = (world, chunk, random, minY, maxY, rangeY) -> {
-        int x = (chunk.pos.x() * 16) + random.nextInt(16);
-        int z = (chunk.pos.z() * 16) + random.nextInt(16);
+        int x = (chunk.pos.x() * 16) + random.nextInt(16) + DECORATION_OFFSET;
+        int z = (chunk.pos.z() * 16) + random.nextInt(16) + DECORATION_OFFSET;
 
         return new TilePos(x, maxY, z);
     };
 
     public static PositionSelector HeightRangeUniform = (world, chunk, random, minY, maxY, rangeY) -> {
-        int x = (chunk.pos.x() * 16) + random.nextInt(16);
-        int z = (chunk.pos.z() * 16) + random.nextInt(16);
+        int x = (chunk.pos.x() * 16) + random.nextInt(16) + DECORATION_OFFSET;
+        int z = (chunk.pos.z() * 16) + random.nextInt(16) + DECORATION_OFFSET;
         int y = minY + random.nextInt(rangeY);
         return new TilePos(x, y, z);
     };
 
     public static PositionSelector HeightRangeUniformFromOcean = (world, chunk, random, minY, maxY, rangeY) -> {
-        int x = (chunk.pos.x() * 16) + random.nextInt(16);
-        int z = (chunk.pos.z() * 16) + random.nextInt(16);
+        int x = (chunk.pos.x() * 16) + random.nextInt(16) + DECORATION_OFFSET;
+        int z = (chunk.pos.z() * 16) + random.nextInt(16) + DECORATION_OFFSET;
         int y = world.getWorldType().getOceanY() + random.nextInt(rangeY - 8) + 4;
         return new TilePos(x, y, z);
     };
 
     public static PositionSelector UpperHeightRangeUniform = (world, chunk, random, minY, maxY, rangeY) -> {
-        int x = (chunk.pos.x() * 16) + random.nextInt(16);
-        int z = (chunk.pos.z() * 16) + random.nextInt(16);
+        int x = (chunk.pos.x() * 16) + random.nextInt(16) + DECORATION_OFFSET;
+        int z = (chunk.pos.z() * 16) + random.nextInt(16) + DECORATION_OFFSET;
         int y = rangeY / 2 + random.nextInt(rangeY - 8) + 4;
         return new TilePos(x, y, z);
     };
 
     public static PositionSelector HeightRangeBiasedTop = (world, chunk, random, minY, maxY, rangeY) -> {
-        int x = (chunk.pos.x() * 16) + random.nextInt(16);
-        int z = (chunk.pos.z() * 16) + random.nextInt(16);
+        int x = (chunk.pos.x() * 16) + random.nextInt(16) + DECORATION_OFFSET;
+        int z = (chunk.pos.z() * 16) + random.nextInt(16) + DECORATION_OFFSET;
         int y = minY + random.nextInt(random.nextInt(rangeY - (rangeY / 16)) + (rangeY / 16));
         return new TilePos(x, y, z);
     };
 
     public static PositionSelector SurfaceBlock = (world, chunk, random, minY, maxY, rangeY) -> {
-        int x = (chunk.pos.x() * 16) + random.nextInt(16);
-        int z = (chunk.pos.z() * 16) + random.nextInt(16);
+        int x = (chunk.pos.x() * 16) + random.nextInt(16) + DECORATION_OFFSET;
+        int z = (chunk.pos.z() * 16) + random.nextInt(16) + DECORATION_OFFSET;
         int y = world.getHeightValue(x, z);
         return new TilePos(x, y, z);
     };
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/gui.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/gui.lang
index de2a55a7a..d97a06674 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/gui.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/gui.lang
@@ -292,6 +292,7 @@ gui.options.page.debug.button.crash.hard=Crash Hard
 gui.options.page.debug.button.music.skip=Force Ambient Music
 gui.options.page.debug.button.garbage_collect=Run Garbage Collector
 gui.options.page.debug.button.reload_commands=Reload Commands
+gui.options.page.debug.button.reset_hud_onboarding=Reset HUD Editor Onboarding
 
 gui.options.page.hidden.title=Hidden Options
 gui.options.page.hidden.category.general=General
diff --git a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
index 0c5ac011d..971a45f1e 100644
--- a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
+++ b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
@@ -134,7 +134,6 @@ public class MinecraftServer
     public int sleepPercentage = 100;
     public int maxPlayers = 20;
     public int viewDistance = 10;
-    public int particleRenderDistance = 10;
     public Gamemode defaultGamemode;
     public static String statsToken;
     public static boolean statsStatus;
@@ -243,7 +242,6 @@ public class MinecraftServer
         NetworkManager.TIMEOUT_TIME = propertyManager.getIntProperty("login-timeout-time", 1800 * 50);
         maxPlayers = propertyManager.getIntProperty("max-players", 20);
         viewDistance = propertyManager.getIntProperty("view-distance", 10);
-        particleRenderDistance = Math.max(1, Math.min(24, propertyManager.getIntProperty("particle-render-distance", 10)));
         language = propertyManager.getStringProperty("language", "en_US");
         disablePhotoMode = propertyManager.getBooleanProperty("disable-photomode", false);
         name = propertyManager.getStringProperty("name", "");
diff --git a/game/server/src/main/java/net/minecraft/server/entity/EntityTrackerEntryImpl.java b/game/server/src/main/java/net/minecraft/server/entity/EntityTrackerEntryImpl.java
index ddcd470ec..8bcccd211 100644
--- a/game/server/src/main/java/net/minecraft/server/entity/EntityTrackerEntryImpl.java
+++ b/game/server/src/main/java/net/minecraft/server/entity/EntityTrackerEntryImpl.java
@@ -6,9 +6,12 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.entity.EntityTrackerEntry;
 import net.minecraft.core.net.entity.NetEntityHandler;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.net.packet.PacketMoveEntity;
 import net.minecraft.core.net.packet.Packet;
+import net.minecraft.core.net.packet.PacketSetRiding;
 import net.minecraft.core.net.packet.PacketSleep;
+import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.net.packet.PacketSetEntityMotion;
 import net.minecraft.core.net.packet.PacketRemoveEntity;
 import net.minecraft.core.net.packet.PacketTeleportEntity;
@@ -19,6 +22,7 @@ import net.minecraft.core.net.packet.PacketSetEquippedItem;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.data.SynchedEntityData;
 import net.minecraft.server.entity.player.PlayerServer;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.HashSet;
 import java.util.List;
@@ -43,6 +47,7 @@ public class EntityTrackerEntryImpl implements EntityTrackerEntry {
     private boolean firstUpdateDone;
     private final boolean shouldSendMotionUpdates;
     private int ticksSinceLastTeleport;
+    private IVehicle lastTrackedVehicle;
     private final SynchedEntityData synchedEntityData;
     public boolean playerEntitiesUpdated;
     public Set<PlayerServer> trackedPlayers;
@@ -62,6 +67,7 @@ public class EntityTrackerEntryImpl implements EntityTrackerEntry {
         encodedPosZ = MathHelper.floor(entity.z * 32D);
         encodedRotationYaw = MathHelper.floor_float((entity.yRot * 256F) / 360F);
         encodedRotationPitch = MathHelper.floor_float((entity.xRot * 256F) / 360F);
+        lastTrackedVehicle = entity.vehicle;
     }
 
     @Override
@@ -97,7 +103,7 @@ public class EntityTrackerEntryImpl implements EntityTrackerEntry {
             int dy = entityY - encodedPosY;
             int dz = entityZ - encodedPosZ;
             Packet packet = null;
-            boolean hasMoved = java.lang.Math.abs(entityX) >= 8 || java.lang.Math.abs(entityY) >= 8 || java.lang.Math.abs(entityZ) >= 8;
+            boolean hasMoved = java.lang.Math.abs(dx) >= 2 || java.lang.Math.abs(dy) >= 2 || java.lang.Math.abs(dz) >= 2;
             boolean hasLooked = java.lang.Math.abs(entityYaw - encodedRotationYaw) >= 8 || java.lang.Math.abs(entityPitch - encodedRotationPitch) >= 8;
             if(dx < -128 || dx >= 128 || dy < -128 || dy >= 128 || dz < -128 || dz >= 128 || ticksSinceLastTeleport > 400) {
                 ticksSinceLastTeleport = 0;
@@ -149,6 +155,24 @@ public class EntityTrackerEntryImpl implements EntityTrackerEntry {
             sendPacketToTrackedPlayersAndTrackedEntity(new PacketEntityNickname(trackedEntity.id, ((Mob) trackedEntity).nickname, ((Mob) trackedEntity).chatColor));
             trackedEntity.hadNicknameSet = false;
         }
+        if (trackedEntity.additionalDataChanged) {
+            sendPacketToTrackedPlayers(new PacketEntityTagData(trackedEntity));
+            trackedEntity.additionalDataChanged = false;
+        }
+
+        if (trackedEntity.vehicle != lastTrackedVehicle) {
+            lastTrackedVehicle = trackedEntity.vehicle;
+            sendPacketToTrackedPlayers(createRidingPacket());
+        }
+    }
+
+    private @NotNull PacketSetRiding createRidingPacket() {
+        if (trackedEntity.vehicle instanceof Entity) {
+            return new PacketSetRiding(trackedEntity, (Entity) trackedEntity.vehicle);
+        } else if (trackedEntity.vehicle instanceof TileEntity tileEntity) {
+            return new PacketSetRiding(trackedEntity, tileEntity.tilePos.x, tileEntity.tilePos.y, tileEntity.tilePos.z);
+        }
+        return new PacketSetRiding(trackedEntity, null); // dismount
     }
 
     public void sendPacketToTrackedPlayers(Packet packet) {
@@ -178,8 +202,10 @@ public class EntityTrackerEntryImpl implements EntityTrackerEntry {
         if(playerServer == trackedEntity) {
             return;
         }
-        double dx = playerServer.x - (double)(encodedPosX / 32);
-        double dz = playerServer.z - (double)(encodedPosZ / 32);
+
+        double dx = playerServer.x - trackedEntity.x;
+        double dz = playerServer.z - trackedEntity.z;
+
         if(dx >= (double)(-trackingDistance) && dx <= (double)trackingDistance && dz >= (double)(-trackingDistance) && dz <= (double)trackingDistance) {
             if(!trackedPlayers.contains(playerServer)) {
                 trackedPlayers.add(playerServer);
@@ -203,6 +229,12 @@ public class EntityTrackerEntryImpl implements EntityTrackerEntry {
                         playerServer.playerNetServerHandler.sendPacket(new PacketSleep(trackedEntity, 0, MathHelper.floor(trackedEntity.x), MathHelper.floor(trackedEntity.y), MathHelper.floor(trackedEntity.z)));
                     }
                 }
+                if (trackedEntity.vehicle != null) {
+                    playerServer.playerNetServerHandler.sendPacket(createRidingPacket());
+                }
+                if (trackedEntity.passenger != null) {
+                    playerServer.playerNetServerHandler.sendPacket(new PacketSetRiding(trackedEntity.passenger, trackedEntity));
+                }
             }
         } else if(trackedPlayers.contains(playerServer)) {
             trackedPlayers.remove(playerServer);
diff --git a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
index a9dd6427b..676660862 100644
--- a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
@@ -6,6 +6,7 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.*;
 import net.minecraft.core.crafting.ContainerListener;
 import net.minecraft.core.entity.*;
+import net.minecraft.core.entity.animal.MobPig;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.ProjectileArrow;
 import net.minecraft.core.enums.EnumSleepStatus;
@@ -22,6 +23,7 @@ import net.minecraft.core.world.ICarriable;
 import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkSection;
+import net.minecraft.core.world.pos.ChunkPos;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.server.entity.EntityTrackerImpl;
@@ -183,17 +185,7 @@ public class PlayerServer extends Player implements ContainerListener {
         playerController.tick();
         ticksOfInvuln--;
         containerMenu.broadcastChanges();
-
-        ItemStack heldItem = inventory.getHeldItemStack();
-        if (!ItemStack.areItemStacksEqual(heldItem, lastHeldItem))
-        {
-            if (playerNetServerHandler != null)
-            {
-                playerNetServerHandler.sendPacket(new PacketContainerSetSlot(-1, -1, heldItem));
-            }
-            lastHeldItem = heldItem == null ? null : heldItem.copy();
-        }
-
+        broadcastCarried(containerMenu);
         for (int i = 0; i < 5; i++)
         {
             ItemStack itemstack = getEquipmentInSlot(i);
@@ -310,7 +302,7 @@ public class PlayerServer extends Player implements ContainerListener {
                 {
                     usePersonalCraftingInventory();
                 }
-                if (vehicle != null)
+                if (vehicle != null && !(vehicle instanceof MobPig))
                 {
                     startRiding(vehicle);
                 }
@@ -372,6 +364,10 @@ public class PlayerServer extends Player implements ContainerListener {
                 {
                     WorldServer worldserver = mcServer.getDimensionWorld(dimension);
                     loadedChunks.remove(chunkCoord);
+                    ChunkPos sentChunkPos = new ChunkPos(chunkCoord.x, chunkCoord.z);
+                    if (worldserver.isChunkLoaded(sentChunkPos)) {
+                        worldserver.getChunk(sentChunkPos, true).sentToClients = true;
+                    }
                     playerNetServerHandler.sendPacket(new PacketBlockRegionUpdate(chunkCoord.x * Chunk.CHUNK_SIZE_X, 0, chunkCoord.z * Chunk.CHUNK_SIZE_Z, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, worldserver));
                     List<TileEntity> list = worldserver.getBlockEntitiesWithinBounds(chunkCoord.x * Chunk.CHUNK_SIZE_X, 0, chunkCoord.z * Chunk.CHUNK_SIZE_Z, chunkCoord.x * Chunk.CHUNK_SIZE_X + Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y, chunkCoord.z * Chunk.CHUNK_SIZE_Z + Chunk.CHUNK_SIZE_Z);
                     for (int j = 0; j < list.size(); j++)
@@ -616,17 +612,9 @@ public class PlayerServer extends Player implements ContainerListener {
         {
             return;
         }
-        if (isChangingQuantityOnly)
+        if (playerNetServerHandler != null)
         {
-            return;
-        }
-        else
-        {
-            if (playerNetServerHandler != null)
-            {
-                playerNetServerHandler.sendPacket(new PacketContainerSetSlot(container.containerId, i, itemstack));
-            }
-            return;
+            playerNetServerHandler.sendPacket(new PacketContainerSetSlot(container.containerId, container.getStateId(), i, itemstack));
         }
     }
 
@@ -638,13 +626,12 @@ public class PlayerServer extends Player implements ContainerListener {
     @Override
 	public void updateCraftingInventory(MenuAbstract container, List<ItemStack> list)
     {
-
-        //playernetserverhandler returning false?
+        ItemStack held = inventory.getHeldItemStack();
         if (playerNetServerHandler != null)
         {
-            playerNetServerHandler.sendPacket(new PacketContainerSetContent(container.containerId, list));
-//            playerNetServerHandler.sendPacket(new ContainerSetSlotPacket(-1, -1, inventory.getHeldItemStack()));
+            playerNetServerHandler.sendPacket(new PacketContainerSetContent(container.containerId, container.getStateId(), list, held));
         }
+        remoteCarried = held == null ? null : held.copy();
     }
 
     @Override
@@ -659,23 +646,39 @@ public class PlayerServer extends Player implements ContainerListener {
         closeCraftingGui();
     }
 
-    public void updateHeldItem()
+    public void setRemoteCarried(ItemStack stack)
     {
-        if (isChangingQuantityOnly)
+        remoteCarried = stack == null ? null : stack.copy();
+    }
+
+    public void broadcastCarried(MenuAbstract container)
+    {
+        if (playerNetServerHandler == null)
         {
             return;
         }
-        else
+        ItemStack held = inventory.getHeldItemStack();
+        if (ItemStack.areItemStacksEqual(held, remoteCarried))
         {
-            playerNetServerHandler.sendPacket(new PacketContainerSetSlot(-1, -1, inventory.getHeldItemStack()));
             return;
         }
+        container.incrementStateId();
+        playerNetServerHandler.sendPacket(new PacketContainerSetSlot(-1, container.getStateId(), -1, held));
+        remoteCarried = held == null ? null : held.copy();
+    }
+
+    public void broadcastFullState(MenuAbstract container)
+    {
+        container.incrementStateId();
+        updateCraftingInventory(container, container.getSlotStackList());
+        container.resetRemoteSlots();
     }
 
     public void closeCraftingGui()
     {
         containerMenu.onCraftGuiClosed(this);
         containerMenu = inventoryMenu;
+        broadcastFullState(containerMenu);
     }
 
     public void setMovementType(float f, float f1, boolean flag, boolean flag1, float f2, float f3)
@@ -758,6 +761,11 @@ public class PlayerServer extends Player implements ContainerListener {
         this.playerNetServerHandler.sendPacket(new PacketEntityFling(this.id, this.xd, this.yd, this.zd, this.pushTime, this.pushesThisTick));
     }
 
+    @Override
+    public void onVehicleFlung(final Entity vehicle) {
+        this.playerNetServerHandler.sendPacket(new PacketEntityFling(vehicle.id, vehicle.xd, vehicle.yd, vehicle.zd, vehicle.pushTime, vehicle.pushesThisTick));
+    }
+
     @Override
     public void setHeldObject(@Nullable ICarriable heldObject) {
         super.setHeldObject(heldObject);
@@ -816,7 +824,6 @@ public class PlayerServer extends Player implements ContainerListener {
     private ItemStack[] playerInventory = {
             null, null, null, null, null
     };
-    private ItemStack lastHeldItem;
     private int currentWindowId;
-    public boolean isChangingQuantityOnly;
+    private ItemStack remoteCarried;
 }
diff --git a/game/server/src/main/java/net/minecraft/server/net/PlayerList.java b/game/server/src/main/java/net/minecraft/server/net/PlayerList.java
index 8719b4eab..5c0b843da 100644
--- a/game/server/src/main/java/net/minecraft/server/net/PlayerList.java
+++ b/game/server/src/main/java/net/minecraft/server/net/PlayerList.java
@@ -6,6 +6,8 @@ import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.animal.MobPig;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.UUIDHelper;
@@ -122,6 +124,19 @@ public class PlayerList
         world.getChunkProvider().prepareChunk((int) player.x >> 4, (int) player.z >> 4);
     }
 
+    public void resendChunksAfterTeleport(PlayerServer player)
+    {
+        int viewChunkX = (int) player.viewingX >> 4;
+        int viewChunkZ = (int) player.viewingZ >> 4;
+        int chunkX = (int) player.x >> 4;
+        int chunkZ = (int) player.z >> 4;
+        if (viewChunkX == chunkX && viewChunkZ == chunkZ)
+        {
+            return;
+        }
+        syncPlayerDimension(player);
+    }
+
     public int getMaxTrackingDistance()
     {
         return playerManagers.get(0).getMaxTrackingDistance();
@@ -163,8 +178,13 @@ public class PlayerList
 
     public void playerLoggedOut(PlayerServer entityplayermp)
     {
+        Entity mount = entityplayermp.vehicle instanceof MobPig ? (Entity) entityplayermp.vehicle : null;
         playerIo.save(entityplayermp);
-        server.getDimensionWorld(entityplayermp.dimension).setEntityDead(entityplayermp);
+        WorldServer worldserver = server.getDimensionWorld(entityplayermp.dimension);
+        worldserver.setEntityDead(entityplayermp);
+        if (mount != null) {
+            worldserver.setEntityDead(mount);
+        }
         playerEntities.remove(entityplayermp);
         getPlayerManager(entityplayermp.dimension).removePlayer(entityplayermp);
     }
@@ -217,12 +237,15 @@ public class PlayerList
         newPlayer.id = previousPlayer.id;
         newPlayer.chatColor = previousPlayer.chatColor;
         newPlayer.nickname = previousPlayer.nickname;
-        newPlayer.gamemode = previousPlayer.gamemode;
+        newPlayer.setGamemodeOnLogin(previousPlayer.gamemode);
+        newPlayer.rotationLock = previousPlayer.rotationLock;
+        newPlayer.rotationLockHorizontal = previousPlayer.rotationLockHorizontal;
+        newPlayer.rotationLockVertical = previousPlayer.rotationLockVertical;
+        newPlayer.placementModeOverride = previousPlayer.placementModeOverride;
         newPlayer.playerNetServerHandler = previousPlayer.playerNetServerHandler;
 		newPlayer.inventory.transferAllContents(previousPlayer.inventory);
         newPlayer.playerConfig.config = previousPlayer.playerConfig.config;
         WorldServer worldserver = server.getDimensionWorld(previousPlayer.dimension);
-        //entityplayermp1.setGamemodeOnLogin(entityplayermp.gamemode);
         if (chunkcoordinates != null)
         {
             final TilePos bedCoordinates = Player.getValidBedSpawnCoordinates(this.server.getDimensionWorld(previousPlayer.dimension), chunkcoordinates);
@@ -260,10 +283,15 @@ public class PlayerList
         Dimension lastDim = Dimension.getDimensionList().get(playerServer.dimension);
         Dimension newDim = Dimension.getDimensionList().get(targetDim);
 
+        Entity mount = playerServer.vehicle instanceof MobPig ? (Entity) playerServer.vehicle : null;
+
         playerServer.dimension = targetDim;
         WorldServer worldserver1 = server.getDimensionWorld(playerServer.dimension);
         playerServer.playerNetServerHandler.sendPacket(new PacketRespawn((byte) playerServer.dimension, (byte) Registries.WORLD_TYPES.getNumericIdOfItem(worldserver1.getWorldType())));
         worldserver.removePlayer(playerServer);
+        if (mount != null) {
+            worldserver.removePlayer(mount);
+        }
         playerServer.removed = false;
         double x = playerServer.x;
         double y = playerServer.y;
@@ -306,6 +334,16 @@ public class PlayerList
         setTime(playerServer, worldserver1);
         initializePlayerObject(playerServer);
         playerServer.playerNetServerHandler.sendPacket(new PacketGameRule(server.getDimensionWorld(0).getLevelData().getGameRules()));
+        playerServer.playerNetServerHandler.sendPacket(new PacketSetHotbarOffset(playerServer.inventory.getHotbarOffset()));
+        playerServer.playerNetServerHandler.sendPacket(new PacketSetCarriedItem(playerServer.inventory.getCurrentSlot()));
+
+        if (mount != null && playerServer.isAlive()) {
+            mount.removed = false;
+            mount.world = worldserver1;
+            mount.moveTo(playerServer.x, playerServer.y, playerServer.z, playerServer.yRot, mount.xRot);
+            worldserver1.entityJoinedWorld(mount);
+            playerServer.playerNetServerHandler.sendPacket(new PacketSetRiding(playerServer, mount));
+        }
     }
 
     public void onTick()
diff --git a/game/server/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java b/game/server/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java
index 930940cd7..57c76d7fe 100644
--- a/game/server/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java
+++ b/game/server/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java
@@ -121,16 +121,18 @@ public class ConsoleCommandSource implements CommandSource, IServerCommandSource
 
     @Override
     public void teleportPlayerToPos(Player player, double x, double y, double z) {
-        if (player instanceof PlayerServer)
+        if (player instanceof PlayerServer) {
             ((PlayerServer) player).playerNetServerHandler.teleport(x, y, z);
-        else throw new IllegalStateException("Player is not an instance of PlayerServer");
+            this.server.playerList.resendChunksAfterTeleport((PlayerServer) player);
+        } else throw new IllegalStateException("Player is not an instance of PlayerServer");
     }
 
     @Override
     public void teleportPlayerToPosAndRot(Player player, double x, double y, double z, float yaw, float pitch) {
-        if (player instanceof PlayerServer)
+        if (player instanceof PlayerServer) {
             ((PlayerServer) player).playerNetServerHandler.teleportAndRotate(x, y, z, yaw, pitch);
-        else throw new IllegalStateException("Player is not an instance of PlayerServer");
+            this.server.playerList.resendChunksAfterTeleport((PlayerServer) player);
+        } else throw new IllegalStateException("Player is not an instance of PlayerServer");
     }
 
     @Override
diff --git a/game/server/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java b/game/server/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
index 9475420f2..b07067416 100644
--- a/game/server/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
+++ b/game/server/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
@@ -125,16 +125,18 @@ public class ServerCommandSource implements CommandSource, IServerCommandSource
 
     @Override
     public void teleportPlayerToPos(Player player, double x, double y, double z) {
-        if (player instanceof PlayerServer)
+        if (player instanceof PlayerServer) {
             ((PlayerServer) player).playerNetServerHandler.teleport(x, y, z);
-        else throw new IllegalStateException("Player is not an instance of PlayerServer");
+            this.server.playerList.resendChunksAfterTeleport((PlayerServer) player);
+        } else throw new IllegalStateException("Player is not an instance of PlayerServer");
     }
 
     @Override
     public void teleportPlayerToPosAndRot(Player player, double x, double y, double z, float yaw, float pitch) {
-        if (player instanceof PlayerServer)
+        if (player instanceof PlayerServer) {
             ((PlayerServer) player).playerNetServerHandler.teleportAndRotate(x, y, z, yaw, pitch);
-        else throw new IllegalStateException("Player is not an instance of PlayerServer");
+            this.server.playerList.resendChunksAfterTeleport((PlayerServer) player);
+        } else throw new IllegalStateException("Player is not an instance of PlayerServer");
     }
 
     @Override
